'use strict';
var system = require('system')
  , fs = require('fs')
  , router = require('./router')
  , getPass = require('./get-pass')

var argv = system.args
  , quantity = parseFloat(argv[1], 10)

if (argv.length !== 2 || isNaN(quantity)) {
  console.log(argv[0], '[quantity]')
  phantom.exit(1)
}

router.navigate('http://account.skrill.com')

router.set('https://account.skrill.com/login', function() {
  console.log('logging in')

  getPass('skrill', (err, pass, email) => {
    if (err) return error(err)
    this.evaluate(function(pass, email) {
      $('#user_authentication_email').val(email).change()
      $('#user_authentication_password').val(pass).change()
      $('[name=commit]').click()
    }, pass, email)
  })
})

router.set('https://account.skrill.com/dashboard', function() {
  console.log('Balance:', this.evaluate(function() {
    return $('#account-panel .balance').text()
  }))

  dashboard()
})

function dashboard() {
  if (quantity)
    router.navigate('https://account.skrill.com/fund_uploads/new')
  else
    phantom.exit()
}

router.set('https://account.skrill.com/fund_uploads/new', function() {
  this.evaluate(function() {
    $('#fund_upload_fund_upload_method_bank').click()
    $('#fund_upload_payment_option_ideal').click()
    $('#fund_upload_issuer').val('ABNANL2A').change()
    $('[name=commit]').click()
  })
})

router.set('https://account.skrill.com/fund_uploads/bank_uploads/step/1', function() {
  this.evaluate(function(quantity) {
    if (typeof $ == 'undefined') return
    $('#fund_upload_amount').val(quantity).change()
    $('[name=commit]').click()
  }, quantity)
})

router.set('https://www.abnamro.nl/en/ideal/identification.do', identify)
router.set('https://www.abnamro.nl/en/ideal/mobile.do', identify)

function identify() {
  getPass('abnamro', (err, _, account, card) => {
    if (err) return error(err)
    this.evaluate(function(account, card) {
      $('#e2Radio').click().change()
      $('[name=accountNumber]').val(account).change()
      $('[name=cardNumber]').val(card).change()
      $('[name=buttonContinue]').click()
    }, account, card)
  })
}

router.set('https://www.abnamro.nl/en/ideal/unconnected.do', function() {
  console.log('Challenge:', this.evaluate(function() {
    return document.querySelector('.challengenew').textContent
  }))

  this.evaluate(function(response) {
    document.querySelector('[name=response]').value = response
    document.querySelector('form').submit()
  }, system.stdin.readLine())
})

router.set('https://www.abnamro.nl/en/ideal/selectdebitaccount.do', function() {
  this.evaluate(function() {
    document.querySelector('form').submit()
  })
})

router.set('https://www.abnamro.nl/en/ideal/confirm.do', function() {
  this.evaluate(function() {
    window.location = document.querySelector('[src="./imgs/bttn/bestelling_afronden.gif"]').parentNode.href
  })

  quantity = null
})

function error(err) {
  console.error(err)
  phantom.exit(1)
}
