'use strict';
var spawn = require('child_process').spawn

module.exports = function getPass(service, cb) {
  var child = spawn('pass', ['show', service])
    , stdout = ''
    , stderr = ''

  child.stdout.on('data', function(chunk) { stdout += chunk })
  child.stderr.on('data', function(chunk) { stderr += chunk })

  child.on('exit', function(code) {
    if (code !== 0) {
      var err = new Error('failed to acquire password: ' + stderr)
      return cb(err)
    }
    
    var data = stdout.split('\n')
      , pass = data[0]
      , user = data[1]
    
    cb(null, ...data)
  })
}
