'use strict';
var routes = Object.create(null)
  , router = exports

var page = require('webpage').create()
page.viewportSize = { width: 1366, height: 768 }

router.navigate = function() {
  var args = [].slice.call(arguments)
  args.push(dispatch)
  return page.open.apply(page, args)
}

router.set = function(url, handler) {
  routes[url] = handler
}

function dispatch(status) {
  page.onLoadFinished = dispatch

  var url = page.url
  if (status && status !== 'success') {
    var err = new Error('failed to load ' + url)
    throw err
  }

  var cb = routes[url.replace(/\?.*$/, '')]
  if (cb) {
    console.log('dispatching', url)
    return cb.call(page)
  }
  console.log('waiting at', url)
}
